#include<cstdio>
#include <iostream>
#include<cmath>
#include <string>
using namespace std;
int main()
{
    int t, n, m;
    long long int a[100005], b[100005], c[100005], d[100005];
    scanf("%d", &t);
    for (int i=0; i<t; i++)
        {
            d[i]==0;
            scanf("%d%d", &n, &m);
            for(int j=0; j<n; j++)
                {
                    scanf("%lld", &a[j]);
                    if(j==1) c[i]=a[i*2+1]-a[i*2];
                }
            for(int j=0; j<m; j++)
                {
                    scanf("%lld", &b[i]);
                    if(c[i]==1) d[i]++;
                    else if(abs((b[i]-a[0])%c[i])==0) d[i]++;
                }
        }
    for(int i=0; i<t; i++)
        {
            if(d[i]==1) printf("0");
            else printf("1");
        }
    return 0;
}